"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.PKCS7Padding = void 0;
class PKCS7Padding {
    addPadding(data, blockSize) {
        const paddingLength = blockSize - data.length % blockSize;
        return new Uint8Array([...data, ...new Array(paddingLength).fill(paddingLength)]);
    }
    removePadding(data) {
        const paddingLength = data[data.length - 1];
        return data.slice(0, data.length - paddingLength);
    }
}
exports.PKCS7Padding = PKCS7Padding;
