"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.FirestoreCollection = void 0;
const FirestoreDocument_1 = require("./FirestoreDocument");
class FirestoreCollection {
    firestore;
    path;
    constructor(firestore, path) {
        this.firestore = firestore;
        this.path = path;
    }
    async addDocument(key, documentValues) {
        await this.firestore.collection(this.path.fullPath).doc(key).set(documentValues);
    }
    getDocument(key) {
        return new FirestoreDocument_1.FirestoreDocument(this.firestore, this.path.appending(key));
    }
    async removeDocument(key) {
        await this.firestore.doc(this.path.appending(key).fullPath).delete();
    }
    async allDocuments() {
        const documents = await this.firestore.collection(this.path.fullPath).listDocuments();
        return documents.map(document => new FirestoreDocument_1.FirestoreDocument(this.firestore, this.path.appending(document.id)));
    }
}
exports.FirestoreCollection = FirestoreCollection;
