"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.Guid = void 0;
const uuid_1 = require("uuid");
class Guid {
    guidString;
    constructor(guidString) {
        this.guidString = guidString;
    }
    static from(value) {
        const regex = /^[0-9a-fA-F]{8}-[0-9a-fA-F]{4}-4[0-9a-fA-F]{3}-[0-9a-fA-F]{4}-[0-9a-fA-F]{12}$/u;
        if (!regex.test(value))
            throw new Error('Could not parse Guid, guid string is invalid.');
        return new Guid(value.toLowerCase());
    }
    static generate() {
        return new Guid((0, uuid_1.v4)());
    }
    get flatten() {
        return this.guidString;
    }
}
exports.Guid = Guid;
